# -*- coding: utf-8 -*-

import gedit
import gtk


class geditTabSwitcherCloserPlugin(gedit.Plugin):
    #
    #window = GObject.property(type=Gedit.Window)

    def __init__(self):
	self.__gtype_name__ = "geditTabSwitcherCloser"
        gedit.Plugin.__init__(self)

    def activate(self, window):
	handlers = []
        handler_id = window.connect('key-press-event', self.on_key_press_event)
        handlers.append(handler_id)
        window.set_data(self.__gtype_name__+"Handlers", handlers)

    def deactivate(self, window):
        handlers = window.get_data(self.__gtype_name__+"Handlers")
        for handler_id in handlers:
            window.disconnect(handler_id)

    def update_state(self, window):
        pass

    def on_key_press_event(self, window, event):
	
	key = event.keyval
	atab = window.get_active_tab()
	
	if event.state == (gtk.gdk.CONTROL_MASK | gtk.gdk.MOD2_MASK) and key == gtk.keysyms.F4:
		window.close_tab(atab);

	if event.state == (gtk.gdk.CONTROL_MASK | gtk.gdk.MOD2_MASK) and key == gtk.keysyms.t:
		window.create_tab(False);

        if event.state == (gtk.gdk.CONTROL_MASK | gtk.gdk.MOD2_MASK) and (key == gtk.keysyms.Tab):
            tabs = atab.get_parent().get_children()
            tlen = len(tabs)
            i = 0
            tab = atab

            for tab in tabs:
                i += 1
                if tab == atab:
                    break

            if key == gtk.keysyms.ISO_Left_Tab:
                i -= 2

            if i < 0:
                tab = tabs[tlen-1]
            elif i >= tlen:
                tab = tabs[0]
            else:
                tab = tabs[i]

            window.set_active_tab(tab)

            return True

	if event.state == (gtk.gdk.CONTROL_MASK | gtk.gdk.MOD2_MASK | gtk.gdk.SHIFT_MASK) and (key == gtk.keysyms.ISO_Left_Tab):
            tabs = atab.get_parent().get_children()
            tlen = len(tabs)
            i = 0
            tab = atab

            for tab in tabs:
                i += 1
                if tab == atab:
                    break

            if key == gtk.keysyms.ISO_Left_Tab:
                i -= 2

            if i < 0:
                tab = tabs[tlen-1]
            elif i >= tlen:
                tab = tabs[0]
            else:
                tab = tabs[i]

            window.set_active_tab(tab)

            return True

